//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "AddRemv.h"
#include "dlgAddRm.h"
#pragma package(smart_init)
#pragma link "dlgAddRm"
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TAddRemove *)
{
	new TAddRemove(NULL);
}
//---------------------------------------------------------------------------

__fastcall TAddRemove::TAddRemove(TComponent* Owner)
	: TComponent(Owner)
{
	FDest = new TStringList( );
    FSource = new TStringList( );
}
//---------------------------------------------------------------------------

__fastcall TAddRemove::~TAddRemove( )
{
	delete FDest;
    delete FSource;
}
//---------------------------------------------------------------------------

void __fastcall TAddRemove::SetMove( bool aMove )
{
	if ( aMove != FMove )
    	FMove = aMove;
}
//---------------------------------------------------------------------------

void __fastcall TAddRemove::SetDest( TStrings *aStrings )
{
	FDest->Assign( aStrings );
}
//---------------------------------------------------------------------------

void __fastcall TAddRemove::SetSource( TStrings *aStrings )
{
	FSource->Assign( aStrings );
}
//---------------------------------------------------------------------------
//   Source Items
void __fastcall TAddRemove::UpdateSource( void )
{
	int     i;
	if ( FMove )
    {   //   Move  Source ɾ Dest е
    	for ( i = FSource->Count - 1; i >= 0; i-- )
        	if ( FDest->IndexOf( FSource->Strings[i] ) != -1 )
            	FSource->Delete( i );
    }
    else
    {   //   Dest м Source ûе
    	for ( i = FDest->Count - 1; i >= 0; i-- )
        	if ( FSource->IndexOf( FDest->Strings[i] ) == -1 )
            	FSource->Add( FDest->Strings[i] );
    }
}
//---------------------------------------------------------------------------

bool __fastcall TAddRemove::Execute( void )
{
	AddRemvDlg = new TAddRemvDlg( this );
    AddRemvDlg->FMove = this->FMove;
    UpdateSource( );
    AddRemvDlg->listDest->Items->Assign( FDest );
    AddRemvDlg->listSource->Items->Assign( FSource );
	int     nResult = AddRemvDlg->ShowModal( );
    FDest->Assign( AddRemvDlg->listDest->Items );
    FSource->Assign( AddRemvDlg->listSource->Items );
    delete AddRemvDlg;
    return ( nResult == mrOk );
}
//---------------------------------------------------------------------------

namespace Addremv
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TAddRemove)};
		RegisterComponents("MentalCtrls", classes, 0);
	}
}
//---------------------------------------------------------------------------
 