//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "BrwEdit.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TBrowseEdit *)
{
	new TBrowseEdit(NULL);
}
//---------------------------------------------------------------------------

__fastcall TBrowseEdit::TBrowseEdit(TComponent* Owner)
	: TCustomEdit(Owner), FDialog( 0 ), FOnBeforeBrw( 0 ), FOnAfterBrw( 0 )
{
	FButton = new TButton( this );

    FButton->Width = 17;
    FButton->Height = 17;
    FButton->Visible = True;
    FButton->Parent = this;
    FButton->Caption = "...";
    FButton->TabStop = false;
    FButton->OnClick = ButtonClick;

	Text = "";
    ControlStyle >> csSetCaption;
}
//---------------------------------------------------------------------------
__fastcall TBrowseEdit::~TBrowseEdit( )
{
	delete FButton;
}
//---------------------------------------------------------------------------

void __fastcall TBrowseEdit::Notification( TComponent *AComponent, TOperation Operation )
{
	TCustomEdit::Notification( AComponent, Operation );
    if ( ( AComponent == FDialog ) && ( Operation == opRemove ) )
    	FDialog = 0;
}
//---------------------------------------------------------------------------

void __fastcall TBrowseEdit::ButtonClick( TObject *Sender )
{
   	bool        bAccept = false;
	AnsiString  asTemp  = Text;
    if ( FDialog )
    	FDialog->FileName = asTemp;
    if ( FOnBeforeBrw )
    	FOnBeforeBrw( this );
    if ( FDialog )
    	bAccept = FDialog->Execute( );
    if ( bAccept )
    	asTemp = FDialog->FileName;
    if ( FOnAfterBrw )
    	FOnAfterBrw( this, asTemp, bAccept );
    if ( bAccept )
    	Text = asTemp;
}
//---------------------------------------------------------------------------

void __fastcall TBrowseEdit::CreateParams( TCreateParams &Params )
{
	TCustomEdit::CreateParams( Params );
	//  Params->Style &= ~WS_BORDER;
	Params.Style |=  ES_MULTILINE | WS_CLIPCHILDREN;
}
//---------------------------------------------------------------------------

void __fastcall TBrowseEdit::CreateWnd( void )
{
	TCustomEdit::CreateWnd( );
	SetEditRect( );
}
//---------------------------------------------------------------------------

void __fastcall TBrowseEdit::SetDialog( TOpenDialog *aDialog )
{
	FDialog = aDialog;
	if ( aDialog )
    	aDialog->FreeNotification( this );
}
//---------------------------------------------------------------------------

int __fastcall TBrowseEdit::GetMinHeight( void )
{
	HDC DC;
	HFONT SaveFont;
	int I, Result;
	TTextMetric SysMetrics, Metrics;

	DC = GetDC( NULL ); //  get system DC
	GetTextMetrics( DC, &SysMetrics );
	SaveFont = SelectObject( DC, Font->Handle );
	GetTextMetrics( DC, &Metrics );
	SelectObject( DC, SaveFont );
	ReleaseDC( 0, DC );
	I = SysMetrics.tmHeight;
	if ( I > Metrics.tmHeight )
		I = Metrics.tmHeight;

	Result = Metrics.tmHeight + I / 4 + GetSystemMetrics( SM_CYBORDER ) * 4 + 2;
	return Result;
}
//---------------------------------------------------------------------------

void __fastcall TBrowseEdit::SetEditRect( void )
{
	TRect Loc;

	SendMessage( Handle, EM_GETRECT, 0, ( long )( &Loc ) );
	Loc.Bottom = ClientHeight + 1;  // +1 is workaround for windows paint bug
	Loc.Right = ClientWidth - FButton->Width - 2;
	Loc.Top = 0;
	Loc.Left = 0;
	SendMessage( Handle, EM_SETRECTNP, 0, ( long )( &Loc ) );
	SendMessage( Handle, EM_GETRECT, 0, ( long )( &Loc ) );  // debug
}
//---------------------------------------------------------------------------

MESSAGE void __fastcall TBrowseEdit::WMSize( TWMSize &Message )
{
	int MinHeight;

	MinHeight = GetMinHeight( );
	// text edit bug: if size to less than minheight, then edit ctrl does
    //  not display the text
	if ( Height < MinHeight )
		Height = MinHeight;
	else if ( FButton != NULL )
    {
    	if ( NewStyleControls )
			FButton->SetBounds( Width - FButton->Width - 5, 0, FButton->Width, Height - 5 );
		else
        	FButton->SetBounds( Width - FButton->Width, 0, FButton->Width, Height );
		SetEditRect( );
	}
}
//---------------------------------------------------------------------------

MESSAGE void __fastcall TBrowseEdit::CMEnter( TWMNoParams &Message )
{
	if ( AutoSelect && !( ControlState.Contains( csLButtonDown ) ) )
		SelectAll( );
}
//---------------------------------------------------------------------------

namespace Brwedit
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TBrowseEdit)};
		RegisterComponents("MentalCtrls", classes, 0);
	}
}
//---------------------------------------------------------------------------
 