unit dlgAbout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ShellAPI;

type
  TAboutDlg = class(TForm)
	imgIcon : TImage;
    labProduct: TLabel;
    labCopyright: TLabel;
    labVersion: TLabel;
	Panel2 : TPanel;
    labUser: TLabel;
	btnOk : TBitBtn;
	btnRegister : TBitBtn;
    labAuthor: TLabel;
    labCompany: TLabel;
    listLicence: TMemo;
    procedure imgIconMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnRegisterClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure WebLinkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutDlg: TAboutDlg;

implementation

{$R *.DFM}

uses About;

procedure TAboutDlg.imgIconMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	If ( Shift = [ssShift, ssCtrl, ssAlt, ssRight] ) Then
    	( Owner As TAboutDialog ).WebLink( labAuthor, 'Raptor<raptorz@yeah.net>' )
    Else
    	( Owner As TAboutDialog ).WebLink( labAuthor, ( Owner As TAboutDialog ).Author );
end;

procedure TAboutDlg.btnRegisterClick(Sender: TObject);
Var
	bAccept : Boolean;
begin
	If ( Assigned( ( Owner As TAboutDialog ).OnRegister ) ) Then
    Begin
    	bAccept := False;
        ( Owner As TAboutDialog ).OnRegister( Self, bAccept );
        Close;
        If ( bAccept ) Then
        	ModalResult := mrCancel
        Else
        	ModalResult := mrOk;
    End;
end;

procedure TAboutDlg.FormShow(Sender: TObject);
Var
	wVerMajor, wVerMinor, wRelMajor, wRelMinor : Word;
begin
    If ( ( Owner As TAboutDialog ).Caption <> '' ) Then
    	Caption := ( Owner As TAboutDialog ).Caption;
    labProduct.Caption := ( Owner As TAboutDialog ).Product;
    wVerMajor := ( Owner As TAboutDialog ).Version SHR 16;
    wVerMinor := Word( ( Owner As TAboutDialog ).Version );
    wRelMajor := ( Owner As TAboutDialog ).Release SHR 16;
    wRelMinor := Word( ( Owner As TAboutDialog ).Release );
    If ( GetSystemDefaultLangID = $804 ) Then
    Begin
    	labCopyright.Caption := 'Ȩ (c) ' + ( Owner As TAboutDialog ).ReleaseDate;
        labUser.Caption := 'Ȩ';
        labVersion.Caption := '汾' + IntToStr( wVerMajor )
        	+ '.' + FormatFloat( '00', wVerMinor )
            + '(' + IntToStr( wRelMajor ) + '.' + FormatFloat( '00', wRelMinor ) + ')';
        btnRegister.Caption := 'ע(&R)';
        btnOk.Caption := 'ȷ(&O)';
    End
    Else
    Begin
    	labCopyright.Caption := 'Copyright (c) ' + ( Owner As TAboutDialog ).ReleaseDate + ' by';
        labUser.Caption := 'Licence to : ';
        labVersion.Caption := 'Version : ' + IntToStr( wVerMajor )
        	+ '.' + FormatFloat( '00', wVerMinor )
            + '(' + IntToStr( wRelMajor ) + '.' + FormatFloat( '00', wRelMinor ) + ')';
        btnRegister.Caption := '&Register';
        btnOk.Caption := '&Ok';
    End;
    ( Owner As TAboutDialog ).WebLink( labCompany, ( Owner As TAboutDialog ).Company );
	( Owner As TAboutDialog ).WebLink( labAuthor, ( Owner As TAboutDialog ).Author );
    If ( ( Assigned( ( Owner As TAboutDialog ).OnRegister ) )
    	AND ( ( Owner As TAboutDialog ).Freeware = False ) ) Then
    Begin
       	labUser.Visible := false;
        btnRegister.Visible := true;
        btnRegister.Enabled := true;
    End
    Else
    Begin
        labUser.Caption := labUser.Caption + ( Owner As TAboutDialog ).UserName;
    	labUser.Visible := true;
        btnRegister.Visible := false;
        btnRegister.Enabled := false;
    End;
    If ( ( Owner As TAboutDialog ).Licence.Count > 0 ) Then
    	listLicence.Lines.Assign( ( Owner As TAboutDialog ).Licence );

    imgIcon.Picture.Icon.Assign( Application.Icon );
end;

procedure TAboutDlg.WebLinkClick(Sender: TObject);
begin
	If ( Sender Is TLabel ) Then
   	With Sender As TLabel Do
    	If ( ShowHint ) Then
        	ShellExecute( Handle, 'open', PChar( Hint ), Nil, '', SW_SHOWNORMAL );
end;

end.

